% Zkladn program, kde uivatel zad potebn parametry a zvol metodu, kterou chce pout.
% Po zadn veho potebnho se spust funkce na pidvn hran, kter je vdy prvn na ad,
% metody se mn a v jejm prbhu.
% 
% Pouit parametry a jejich vznam:
%     uk            ukazatel na nslednky vrchol *
%     nasl          seznam nslednk jednotlivch vrchol *
%     hrany         seznam hran vedoucch do nslednk *
%     vzdal         dlky hran vedoucch do nslednk *
%     souradnice    souadnice vrchol grafu v R^2
%     R             poet iterac metody Monte Carlo
%     vyp           vektor pot vypoutnch hran - tvo se pomoc promnnch maxx a skok
%     opak          poet iterac m. Monte Carlo na dlky cest v algoritmu na F_k v ppad velkho potu vrchol
%     chyba         ukonovac podmnka v algoritmu metody komponent a v m. Monte Carlo viz "opak"
%     komponent     poadovan poet komponent souvislosti v algoritmu metody komponent
%     rychlost      max. rychlost prjezdu pidvanmi hranami
%     omezeni_vzdalenosti_m     omezen dlky pidvanch hran v jednotkch dlky
%     * dle reprezentace grafu seznamem nslednk

clear, clc  % vymaeme ppadn promnn a vyistme pkazov okno

global deko_uzly deko_hrany uk nasl vzdal hrany data_uzly souradnice;     % zadn globlnch promnnch

% Zadn vstupnch dat - je poteba nastavit sprvnou cestu k souborm!
% Nateme "zkladn" informace o grafu:
sit=importdata('d:\zlin_cast2_trb.txt','\n');
[deko_uzly deko_hrany uk nasl vzdal hrany data_uzly]=NACTIDATA4(sit);
% Naten souadnic:
sit=importdata('d:\cast2_uzly_trb.txt','\n');
NACTISOURADNICE(sit)


komponent=[]; chyba=[]; opak=[]; vyp=[];    % pednastaven nkterch hodnot, kter je teba pedat, i kdy nebudou poteba
vzdal=vzdal(2,:);   % budeme pracovat se vzdlenost v sekundch, co je uloeno ve druhm dku pvodn promnn
souradnice=souradnice';       % z vpoetnch dvod potebujeme souadnice vrchol ve sloupcch, v pvodnch datech byly v dcch

% Zadn parametr a metod
disp(' ');
omezeni_vzdalenosti_m=input('Zadejte maximln dlku pidan hrany v metrech: ');
rychlost=input('Zadejte rychlost prjezdu pidvanmi hranami v metrech za sekundu: ');
disp(' ');
disp('Zvolte metodu, kterou chcete potat:');
disp('1 - S_k');
disp('2 - F_k');
disp('3 - Komponenty');
metoda=input('Zadejte slo metody: ');
disp(' ');
switch metoda
    case 1
        disp('Hrany budou vypoutny od 0 po zvolench skocch po nejvy poet vypoutnch hran.');
        true=0;
        while true==0
            pravda=0;
            while pravda==0
                maxx=input('Zadejte nejvy poet vyputnch hran: ');
                if maxx<=max(hrany)
                    pravda=1;
                else disp(' ');
                    disp('CHYBA! Nelze vypustit vc hran, ne graf obsahuje, zadejte znovu:');
                end;
            end;    
            skok=input('Zadejte skoky v potu vypoutnch hran. Nejvy poet hran mus bt nsobkem skoku: ');
            
            if (maxx/skok)==round(maxx/skok)
                true=1;
                vyp=0:skok:maxx;
            else disp(' ');
                 disp('CHYBA! Nejvy poet nen nsobkem skoku, zadejte znovu:');
            end;
        end;
        disp(' ');
        R=input('Zadejte poet opakovn metody Monte Carlo: ');
    case 2
        disp('Hrany budou vypoutny od 0 po zvolench skocch po nejvy poet vypoutnch hran.');
        true=0;
        while true==0
            pravda=0;
            while pravda==0
                maxx=input('Zadejte nejvy poet vyputnch hran: ');
                if maxx<=max(hrany)
                    pravda=1;
                else disp(' ');
                    disp('CHYBA! Nelze vypustit vc hran, ne graf obsahuje, zadejte znovu:');
                end;
            end;    
            skok=input('Zadejte skoky v potu vypoutnch hran. Nejvy poet hran mus bt nsobkem skoku: ');
            
            if (maxx/skok)==round(maxx/skok)
                true=1;
                vyp=0:skok:maxx;
            else disp(' ');
                 disp('CHYBA! Nejvy poet nen nsobkem skoku, zadejte znovu:');
            end;
        end;
        disp(' ');
        R=input('Zadejte poet opakovn metody Monte Carlo: ');
        if length(uk)>101
            disp(' ');
            disp('V grafu je vc ne 100 vrchol, vpoet dlek nejkratch cest probhne metodou Monte Carlo');
            opak=input('Zadejte zkladn poet opakovn tto metody Monte Carlo: ');
            chyba=input('Zadejte ppustnou chybu - ukonovac podmnku: ');
        end;
    case 3
        true=0;
        while true==0
            komponent=input('Zadejte poet komponent, na kter se m s rozpadnout: ');
            if komponent<=length(uk)-1
                true=1;
            else disp(' ');
                 disp('CHYBA! Komponent neme bt vc, ne je vrchol v grafu, zadejte znovu:');
            end;
        end;
        R=input('Zadejte poet opakovn algoritmu: ');
        chyba=input('Zadejte ppustnou chybu - ukonovac podmnku: ');
end;

disp(' ');
disp('Potm...');
disp(' ');

% Volme funkci na pidvn hran
[vysledky]=pridavani_hran(deko_uzly, souradnice, omezeni_vzdalenosti_m, rychlost, metoda, komponent, R, vyp, chyba, opak);


        