% Funkce na spotn dlek nejkratch cest a nsledn dlch Fk
% v grafu s velkm potem vrchol - spotme odhady hodnot pomoc metody
% Monte Carlo


function [Fks, fs]=cesty_MC(skala, opak, chyba)
           % Fks - dl vsledky Fk
           % fs  - vektor dlek nejkratch cest (na vykreslen histogramu)
global uk nasl vzdal

Fks=zeros(opak,(length(skala)));
fs=zeros(opak,(length(uk)-1));
N=zeros(1,length(skala));
 
% Nejdve potme ze zadanho potu opakovn algoritmu
for s=1:opak
    zacatek=randi(max(nasl));       % nhodn vygeneruje vchoz vrchol
    [delka]=nejkratsi_cesta_vsude(zacatek);    % funkce na nejkrat cesty
        % delka - pole dlek nejkratch cest z vchozho vrcholu
        %         do vech ostatnch vrchol v grafu

    for d=2:length(skala)           
        N(d)=length(find(delka<=skala(d) & delka<Inf))-1;   % poet propojench vrchol, kde delka < x, -1 odeteme vchoz vrchol
    end;
    Fks(s,:)=N/(length(uk)-2);     % Fk dle definice, v kadm dku pro dan vchoz vrchol
    fs(s,:)=delka;     % pprava dat na histogram
end;
        

%  Dle budeme potat tak dlouho, dokud se vsledky nebudou liit maximln
% o zadanou chybu

meanFks=mean(mean(Fks));    % ukonovac kritrium je prmr z vslednho vektoru Fks
odchylka=Inf;               % pednastaven 1. hodnoty odchylky
pocitadlo=1;

while odchylka(end)>chyba
     zacatek=randi(max(nasl));       % nhodn vygeneruje vchoz vrchol
    [delka]=nejkratsi_cesta_vsude(zacatek);    % funkce na nejkrat cesty
    
    for d=2:length(skala)           
        N(d)=length(find(delka<=skala(d) & delka<Inf))-1;
    end;
    Fks(s+pocitadlo,:)=N/(length(uk)-2);
    fs(s+pocitadlo,:)=delka;     % pprava dat na histogram
    meanFks(pocitadlo+1)=mean(mean(Fks));    % zapeme vsledn prmry
    pocitadlo=pocitadlo+1;         
    odchylka(pocitadlo)=abs(meanFks(pocitadlo)-meanFks(pocitadlo-1)); % spotme odchylky
end;

Fks=mean(Fks);          % Fk pro konkrtn k-tici odebranch hran (vektor)
[m,n]=size(fs);
fs=reshape(fs,1,m*n);   % dlky cest peskldme do vektoru
fs(fs==0)=[];           % odstranme 0 (vchoz vrcholy)

  