% Funkce na spotn dlek nejkratch cest a nsledn dlch Fk
% v grafu s malm potem vrchol - potme skuten hodnoty, za vchoz
% volme postupn vechny vrcholy grafu

function [Fks, fs]=cesty_prime_pocitani(skala)
           % Fks - dl vsledky Fk
           % fs  - vektor dlek nejkratch cest (na vykreslen histogramu)
           
        global uk nasl vzdal   

        Fks=zeros((length(uk)-1),(length(skala)));
        fs=zeros((length(uk)-1),(length(uk)-1));
        N=zeros(1,length(skala));
        
        for s=1:length(uk)-1        % pro vechny vrcholy
            zacatek=s;
            [delka]=nejkratsi_cesta_vsude(zacatek);    % funkce na nejkrat cesty
                % delka - pole dlek nejkratch cest z vchozho vrcholu
                %         do vech ostatnch vrchol v grafu

            for d=2:length(skala)           
                N(d)=length(find(delka<=skala(d) & delka<Inf))-1;   % poet propojench vrchol, kde delka < x, -1 odeteme vchoz vrchol
            end;
            Fks(s,:)=N/(length(uk)-2);      % Fk dle definice, v kadm dku pro dan vchoz vrchol
            fs(s,:)=delka;      % pprava dat na histogram
        end;
        
        Fks=mean(Fks);          % Fk pro konkrtn k-tici odebranch hran (vektor)
        fs=reshape(fs,1,((length(uk)-1)^2));    % dlky cest peskldme do vektoru
        fs(fs==0)=[];                           % odstranme 0 (vchoz vrcholy)