
% podmnka neken hran
% Pi danch stvajcch hranch v grafu a nov zvolen hran, kterou
% bychom chtli do grafu pidat, zjiuje, zda se nov hrana k
% s njakou stvajc hranou. Pokud dojde ke ken, funkce se peru,
% nebo nem smysl dl potat - hranu pidat nememe.

% Vstupem funkce je logick promnn "krizi", jej vznam je:
%         0 - hrana se nek, meme ji pidat
%         1 - hrana se k, pidat ji nememe


function krizi=krizeni(souradnice, z, do, hrana)

global uk nasl   

for i=1:length(uk)-1-1      % pro vechny vrcholy krom poslednho
     for j=uk(i):uk(i+1)-1   % pro jejich nslednky
        if nasl(j)>i             % podmnka na vylouen ji dve testovanch hran
            h1=i;
            h2=nasl(j);
            SH=[souradnice(:,h1),souradnice(:,h2)]; % testovan stavajc hrana
            
%           Pokud by hrany mly spolen vrchol, nesm z tohoto vrcholu
%           vychzet stejnm smrem (oetme tak ppad, kdy by propojovan vrchol leel a
%           za vrcholem spojenm testovanou stvajc hranou a byly by na pmce).
%           Maj-li hrany rzn smry, ke konfliktu s mezi nimi nedochz.

            if z==h1 | z==h2 | do==h1 | do==h2      % pokud hrany maj spolen vrchol
                
            %     pezname vrcholy, m si usnadnme nsledujc vpoet
                if z==h1
                    spolecny=z; koncovy1=do; koncovy2=h2;
                elseif z==h2
                    spolecny=z; koncovy1=do; koncovy2=h1;
                elseif do==h1
                    spolecny=do; koncovy1=z; koncovy2=h2;
                elseif do==h2
                    spolecny=do; koncovy1=z; koncovy2=h1;
                end;
                
            %     spotme vektory, zaokrouhlme jejich souadnice na tisciny smrem k 0 a vynsobme *10000, a mme celoseln hodnoty
            %     na hodnoty na 4. a vym desetinnm mst pohlme jako na chybu men, kter by nm brnila v provdn vpot
            %     kvli spornosti je doasn dme do jedn matice
                vektor1=(souradnice(:,koncovy1))-(souradnice(:,spolecny));
                vektor2=(souradnice(:,koncovy2))-(souradnice(:,spolecny));
                vektory=[vektor1, vektor2];
                kladne=vektory>0; zaporne=-1*(vektory<0); znamenka=kladne+zaporne;
                vektory=znamenka.*floor(znamenka.*vektory*10000);
                vektor1=vektory(:,1); vektor2=vektory(:,2);     % vektory zpt rozdlme
                
                nenul=find((vektor2~=0), 1, 'first');   % najdeme nenulov prvek ve vektoru2, nemou bt oba nulov. Jsou-li oba nenulov, vybereme prvn.

                podil=vektor1(nenul)/vektor2(nenul);     % zjistme podl odpovdajcch prvk, tm pak vektor2 zptn pensobme a vektory porovnme
                if (podil>0) & (podil*vektor2==vektor1)      % vektory maj stejn smr a stejn potek -> hrany se pekrvaj
                    krizi=1;                     
                    return
                else krizi=0;
                    continue      % M-li hrany od spolenho vrcholu rznmi smry, ke konfliktu nedojde a je mono testovat dal hranu          
                end;
                
            else % hrany nemaj spolen vrchol
                
                % nejdv musme zjistit, jestli na sece z-do nele
                % nkter z vrchol stvajc, zrovna kontrolovan hrany.
                % Pokud by leel, vrcholy "z" a "do" spojit nememe. Tmto
                % oetme i ppad, kdy by ob hrany leely v jedn pmce
                % a sten splvaly.
                % Ovme postupn pro oba vrcholy. Pokud se budou kit,
                % funkci ukonme.
                for h=1:2
                    c=souradnice(:,z)-souradnice(:,do);
                    d=SH(:,h)-souradnice(:,do); 
                    % je poteba c, d zaokrouhlit a "zceloselnit", abychom se zbavili
                    % chyb men a mohli provdt vpoty
                    matice=[c d];   % z spornch dvod dme doasn c, d do matice
                    kladne=matice>0; zaporne=-1*(matice<0); znamenka=kladne+zaporne;
                    matice=znamenka.*floor(znamenka.*matice*10000);
                    c=matice(:,1); d=matice(:,2);   

                    nenul=find((c~=0), 1, 'first');   % najdeme nenulov prvek v c, nemou bt oba nulov. Jsou-li oba nenulov, vybereme prvn.
                    t=d(nenul)/c(nenul);     % zjistme parametr t z vybran rovnice
                    if (t > 1e-8) && (t < 1 - 1e-8)  % t mus bt z (0,1), nastavena tolerance
                        if t*c==d           % zptn meme vynsobit cel vektory, usnadnme si prci
                            krizi=1;         % je-li jeden vektor t-nsobkem druhho, na sece z-do le vrchol
                            return
                        end;
                    end;
                end;
                
                % V tuto chvli mme hrany, kter nemaj spolen vrchol,
                % ani se nepekrvaj. Ovme, jestli se nek, eenm
                % soustavy linernch rovnic.
                
                A=[hrana(:,1)-hrana(:,2), SH(:,1)-SH(:,2)];
                b= SH(:,1)-hrana(:,2);
                Ab=[A b];               % rozen matice soustavy
                kladne=Ab>0; zaporne=-1*(Ab<0); znamenka=kladne+zaporne;
                Ab=znamenka.*floor(znamenka.*Ab*10000);     % vynsoben a zaokrouhlen, abychom se zbavili chyb men a mohli provdt vpoty
                A=Ab(:,1:2); b=Ab(:,3);
                
                if rank(A)~=rank(Ab)     % soustava nem een, hrany se neprotnou - jsou rovnobn
                    krizi=0;
                else if rank(A)<2           % hrany le v jedn pmce, ale nepekrvaj se
                        krizi=0;             
                    else                % soustava m prv 1 een; jsou-li koeny z (0,1) (s toleranc), hrany se k, jinak se pmky protnou jinde, ne v mst hran
                        parametry=linsolve(A,b);    % soustava lin. rovnic; een = vektor parametr (p,t)'                       
                        if (parametry > 1e-8) & (parametry < 1-(1e-8))  % konvexn kombinace od 0 do 1 -> tolerance
                            krizi=1;
                            return      % ukonen funkce, pokud nalezneme kc hranu
                        else krizi=0;    % Hrany se nek
                        end;
                    end;
                end;
            end;
        end;
    end;
end;
                
                
                