% Algoritmus na pidvn hran do grafu mezi existujcmi vrcholy
% Program pid hrany mezi existujcmi vrcholy, kter nejsou spojeny hranou.
% Pid vdy jen 1 hranu, pak budeme zkoumat vlastnosti "novho" grafu.
% Pidvan hrany se nesm kit se stvajcmi a nesm bt del ne zadan hodnota.
% Na zvr funkce vype vsledky a vykresl grafy.


function [vysledky]=pridavani_hran(deko_uzly, souradnice, omezeni_vzdalenosti_m, rychlost, metoda, komponent, R, vyp, chyba, opak)
            % vysledky - tabulka vsledk s sly propojovanch vrchol, dlkami tchto novch hran
            %  a hodnotami robustnosti nebo zlepen robustnosti, dle zvolen metody

global uk nasl hrany vzdal            

omezeni_vzdalenosti=omezeni_vzdalenosti_m/rychlost;     % pepoet na as v sekundch

poradi_hrany=0;     % poitadlo pidanch hran

% archivace grafu bez pidan hrany
vzdal_puvodni=vzdal;
uk_puvodni=uk;
nasl_puvodni=nasl;
hrany_puvodni=hrany;

% zde nejprve spotme hodnoty pro pvodn graf, bez pidanch hran a
% nastavme dal potebn parametry
switch metoda
    case 1
        [prumer_Sk]=robustness_Sk(vyp, R);
        prumer_Sk_arch=prumer_Sk;       % Ulome hodnoty Sk pro pvodn graf

        data=zeros(5,length(prumer_Sk)+3);  % Pednastaven matice, do kter budeme ukldat 5 nejlepch vsledk a data na vykreslen jejich graf.

    case 2
        % vytvome klu pro distribuci Fk
        krok=10;
        strop=sum(vzdal)/2+omezeni_vzdalenosti;     % strop = souet dlek vech hran + max dlka pidan hrany
        strop=ceil(strop/10)*10;        % zaokrouhlen na cel destky nahoru
        skala=0:krok:strop;
        
        % Podle potu vrchol v grafu se zvol metoda pro vpoet dlek nejkratch cest
        % Do 100 vrchol spotme vechny cesty, nad 100 vrchol pouijeme metodu Monte Carlo
        if length(uk)<=101          
            postup='primy vypocet';
        else postup='MC';
        end;

        [prumer_Fk, fff, osax]=robustness_Fk(skala, vyp, R, postup, chyba, opak);
        prumer_Fk_arch=prumer_Fk;   % Ulome hodnoty Fk pro pvodn graf
        fff_arch=fff;               % Ulome etnosti dlek nejkratch cest pro vykreslen histogramu.
        osax_arch=osax;             % Osa x pro histogramy v pvodnm grafu.
        
        nejlepsi_vysledek=[0 0 0];  % Pednastavme pole pro zpis nejlepho vsledku.
        
    case 3
        [prumerne_hran]=komp_hrany(komponent, R, chyba);
        hran_puvodni_graf=prumerne_hran;    % Poet neprjezdnch hran pro rozpad pvodnho grafu na zadan poet komponent souvislosti
        puvodni_norm=prumerne_hran/(length(hrany)/2);   % Normovan hodnota potu neprjezdnch hran pro pvodn graf, dlme potem hran v grafu
end;

% Vybereme hranu k pidn, zkontrolujeme podmnky na vzdlenost a na
% neken hran a jsou-li splnny, pidme hranu do grafu.
% Po pidn hrany pokraujeme vybranou metodou.

for z=1:length(uk)-1-1                      % pro vechny vrcholy krom poslednho
    nasledniciz=nasl(uk(z):uk(z+1)-1);      % zjistme jeho nslednky
    kam=1:max(nasl);                        % mnoina vech vrchol - prozatm
  % odebrme nslednky a vechny vrcholy < vchoz, protoe tuto cestu jsme u testovali dv
    ne=[1:z, nasledniciz];                  % mnoina 1 a vchoz vrchol a nslednk vchozho vrcholu
    kam(ne)=[];  % odebereme "ne" z mnoiny vech vrchol a zskme tak mnoinu vrchol, do nich chceme pidat hranu
    
    for do=kam                % pro vechny clov vrcholy
         uk=uk_puvodni;          % nastaven pvodnch hodnot
         nasl=nasl_puvodni;
         hrany=hrany_puvodni;
         vzdal=vzdal_puvodni;
        hrana=[souradnice(:,z),souradnice(:,do)];   % nov hrana, souadnice jednotlivch vrchol jsou ve sloupcch
        vzdalenost_m=pdist(hrana');         % eukleidovsk vzdlenost z-do
        vzdalenost=vzdalenost_m/rychlost;   % pepoet na as (v sekundch) pi pouit zadan rychlosti (v m/s)
        
     % nejdve zkontrolujeme podmnku na vzdlenost a pokud je splnna, budeme zjiovat ken hran
        if vzdalenost<=omezeni_vzdalenosti  
        
            [krizi]=krizeni(souradnice, z, do, hrana);  % funkce podmnky na ken
            % Vstupem funkce je logick promnn "krizi", jej vznam je:
    %         0 - hrana se nek, meme ji pidat
    %         1 - hrana se k, pidat ji nememe

            % Pidme hranu do grafu
            if krizi==0                           % podmnka na ken hran
                poradi_hrany=poradi_hrany+1;         % zv poitadlo pidanch hran 
                vk=uk(do+1);                        % dodn nov hrany do grafu, oba smry
                uk(do+1:end)=uk(do+1:end)+1;
                nasl(vk+1:length(nasl)+1)=nasl(vk:length(nasl));
                nasl(vk)=z;
                hrany(vk+1:length(hrany)+1)=hrany(vk:length(hrany));
                hrany(vk)=max(hrany)+1;
                vzdal(vk+1:length(vzdal)+1)=vzdal(vk:length(vzdal));
                vzdal(vk)=vzdalenost;

                vk=uk(z+1);
                uk(z+1:end)=uk(z+1:end)+1;
                nasl(vk+1:length(nasl)+1)=nasl(vk:length(nasl));
                nasl(vk)=do;
                hrany(vk+1:length(hrany)+1)=hrany(vk:length(hrany));
                hrany(vk)=max(hrany);
                vzdal(vk+1:length(vzdal)+1)=vzdal(vk:length(vzdal));
                vzdal(vk)=vzdalenost;                 
                
    % v tuto chvli mme nov graf a meme potat dl - metodou, kterou
    % zvolil uivatel ve startovacm programu.
    % hodnota "metoda" je nastavena na:     1 pro funkci na Sk
    %                                       2 pro funkci na Fk               
    %                                       3 pro funkci na komponenty                             

                switch metoda
                    case 1
                          [prumer_Sk]=robustness_Sk(vyp, R);
                              % prumer_Sk - vektor hodnot S_k pro zadan poty vyputnch hran
                              
                          % Vsledkem je souet tverc rozdlu mezi starm a novm grafem
                          rozdil_Sk=(prumer_Sk - prumer_Sk_arch).^2;
                          rozdil_Sk_sum=sum(rozdil_Sk);

    %                       vytvome tabulku s vsledky
                          vysledky(poradi_hrany,1)=z;
                          vysledky(poradi_hrany,2)=do;
                          vysledky(poradi_hrany,3)=vzdalenost;
                          vysledky(poradi_hrany,4)=rozdil_Sk_sum;

                    % Ulome si data pro vykreslen 5 nejlepch vsledk
                          hodnota=min(data(:,end));
                          if rozdil_Sk_sum > hodnota
                              nejhorsi=find(data(:,end)==hodnota, 1);
                              data(nejhorsi,1:end-3)=prumer_Sk;
                              data(nejhorsi,end-2)=z;
                              data(nejhorsi,end-1)=do;
                              data(nejhorsi,end)=rozdil_Sk_sum;
                          end;
                          
                    case 2
                        [prumer_Fk, fff]=robustness_Fk(skala, vyp, R, postup, chyba, opak);
                    %         prumer_Fk - matice distribuc, dky odpovdaj zadanm potm hran
                    %         fff - matice etnost pro nakreslen histogramu, dky odpovdaj zadanm potm hran
                        
                        % Vsledkem je souet tverc rozdlu mezi starm a novm grafem
                          rozdil_Fk=(prumer_Fk - prumer_Fk_arch).^2;   %
                          rozdil_Fk_sum=sum(sum(rozdil_Fk));    % 2x sum, protoe je to matice

    %                       vytvome tabulku s vsledky
                          vysledky(poradi_hrany,1)=z;
                          vysledky(poradi_hrany,2)=do;
                          vysledky(poradi_hrany,3)=vzdalenost;
                          vysledky(poradi_hrany,4)=rozdil_Fk_sum;

                    % Ulome si data pro vykreslen nejlepho vsledku
                          if rozdil_Fk_sum > nejlepsi_vysledek(3)
                              nejlepsi_vysledek=vysledky(poradi_hrany,:);
                              prumer_Fk_pridana=prumer_Fk;
                              fff_pridana=fff;
                          end;
                                                  
                    case 3
                        [prumerne_hran]=komp_hrany(komponent, R, chyba);
                                % prumerne_hran - prmrn poet vyputnch hran
%                       vytvome tabulku s vsledky
                        vysledky(poradi_hrany,1)=z;
                        vysledky(poradi_hrany,2)=do;
                        vysledky(poradi_hrany,3)=vzdalenost;
                        vysledky(poradi_hrany,4)=prumerne_hran;
                        vysledky(poradi_hrany,5)=prumerne_hran/(length(hrany)/2);
                end;
            end;
        end;
    end;
end;


%     Tabulku vsledk seadme sestupn a nahradme sla vrchol jejich pravmi nzvy
%     Data je poteba mt ve stejnm formtu, pevedeme vechno na "cell"
       vysledky=sortrows(vysledky,-4);

       hr=deko_uzly(vysledky(:,1:2));
       hr=cellstr(hr);
       hod=(round(vysledky(:,3:end)*10000))/10000;  % zaokrouhlen na tisciny
       hodn=cell(size(hod));
       for c=1:size(hod,2)
           hodn(:,c)=cellstr(num2str(hod(:,c)));
       end;

       vysledky=[hr hodn];   
       [radky, ~]=size(vysledky);


% Nakonec vypeme a vykreslme vsledky dle zvolen metody
switch metoda
    case 1
                
        % Zobraz nejlepch 5 vsledk (pokud je jich 5)
        disp('Nejlep vsledky dostaneme pidnm hran:')
        disp(' ');
        disp('        z             do       dlka hrany  hodnota zlepen')
        disp(vysledky(1: min([radky, 5]),:))
        
%        Data pro vykreslen graf
        prazdne=sum(data')==0;    % pokud je mn ne 5 vsledk, przdn dky odebereme
        data(prazdne,:)=[];
        [row, col]=size(data);
        data=sortrows(data,-col);       % uspodme vsledky od nejlepho
        
        % Nakresl grafy
        for kresli=1:row
            figure;
            plot(vyp, prumer_Sk_arch, 'r + --')
            hold on
            plot(vyp, data(kresli,1:end-3), 'g + --')
            tit=['Sk pro vsledek ' num2str(kresli)];
            title(tit)
            legend('Sk pvodn st', 'Sk st s pidanou hranou')
            xlabel('Poet odebranch hran')
            ylabel('Sk')
            hold off
        end;           
       
        vysl=input('Chcete zobrazit tabulku vech vsledk? A/N: ', 's');
        if vysl=='A' | vysl=='a'
            disp(' ');
            disp('        z             do       dlka hrany  hodnota zlepen')
            disp(vysledky)
        end;
            
    case 2        
        % Zobraz nejlep vsledek
        disp('Nejlep vsledek dostaneme pidnm hrany:')
        disp(' ');
        disp('        z             do       dlka hrany  hodnota zlepen')
        disp(vysledky(1,:))
        
        % Nakresl grafy pro Fk
        for kresli=1:length(vyp)
            figure;
            plot(skala, prumer_Fk_arch(kresli,:), 'r', 'LineWidth', 1.3)
            hold on
            plot(skala, prumer_Fk_pridana(kresli,:), 'g', 'LineWidth', 1.3)
            tit=['Fk pro ' num2str(vyp(kresli)) ' odebranch hran' ];
            title(tit)
            legend('Fk pvodn st', 'Fk st s pidanou hranou')
            xlabel('Vzdlenost [s]')
            ylabel('Fk')
            hold off
        end;
        
        % Ped vykreslenm histogram je poteba oezat pebyten sloupce nul a pizpsobit osy
        orezat=[fff_arch; fff_pridana];
        sumorezat=sum(orezat);
        sloupec=find(sumorezat==0, 1, 'first');
        fff_pridana(:,sloupec:end)=[];
        fff_arch(:,sloupec:end)=[];
        osax_arch(sloupec:end)=[];
        maxy=max(max(orezat));
        maxy=(ceil(100*maxy))/100;    % max hodnota na ose y = nejvy etnost zaokrouhlen na setiny nahoru
        
        % Vykresl histogramy
        for h=1:length(vyp)      
            figure;
            bar(osax_arch, fff_arch(h,:),'histc')
            str=['Histogram pvodn st pro ' num2str(vyp(h)) ' odebranch hran'];
            title(str)
            xlabel('Vzdlenost [s]')
            ylabel('Relativn etnost')
            axis([osax_arch(1), osax_arch(end), 0, maxy])
        end;
        
        for k=1:length(vyp)      
            figure;
            bar(osax_arch, fff_pridana(k,:), 'histc')
            str=['Histogram st s pidanou hranou pro ' num2str(vyp(k)) ' odebranch hran'];
            title(str)
            xlabel('Vzdlenost [s]')
            ylabel('Relativn etnost')
            axis([osax_arch(1), osax_arch(end), 0, maxy])
        end
        
        vysl=input('Chcete zobrazit tabulku vech vsledk? A/N: ', 's');
        if vysl=='A' | vysl=='a'
            disp(' ');
            disp('        z             do       dlka hrany  hodnota zlepen')
            disp(vysledky)
        end;
        
    case 3
        absolutni=['Poet neprjezdnch hran v pvodnm grafu: ' num2str(hran_puvodni_graf)];
        normovana=['Normovan hodnota potu neprjezdnch hran: ' num2str(puvodni_norm)];
        disp(absolutni)
        disp(' ');
        disp(normovana)
        disp(' ');
       
%        5 nejlepch vsledk (pokud je jich 5)
       disp('Nejlep vsledky dostaneme pidnm hran:')
       disp(' ');
       disp('        z             do       dlka hrany  poet hran  normovan hodnota')
       disp(vysledky(1: min([radky, 5]),:))
             
       vysl=input('Chcete zobrazit tabulku vech vsledk? A/N: ', 's');
       if vysl=='A' | vysl=='a'
           disp(' ');
           disp('        z             do       dlka hrany  poet hran  normovan hodnota')
           disp(vysledky)
       end;

end;

