% Funkce pro spotn F_k pro zadan poty vyputnch hran
        % Nhodn vypust hrany v poadovanm potu
        % Pro kad zadan poet hran zjist dlky nejkratch cest a
        % vypot z nich distribuci dle definice
        
%  Vstup:  prumer_Fk - matice distribuc, dky odpovdaj zadanm potm hran
%           fff - matice etnost pro nakreslen histogramu, dky odpovdaj zadanm potm hran
%           osax - osax pro histogram

function [prumer_Fk, fff, osax]=robustness_Fk(skala, vyp, R, postup, chyba, opak)
%         uk, nasl, hrany, vzdal - zadn grafu
%         skala - vektor diskrtnch hodnot x, pro kter potme distribuci
%         vyp - vektor pot vypoutnch hran, vol uivatel
%         R - poet iterac metody Monte Carlo, vol uivatel
%         postup - parametr pro volbu metody na vpoet dlek nejkratch cest a dlch vsledk
%         chyba - ukonovac podmnka pro vpoet cest metodou Monte Carlo
%         opak - poet opakovn algoritmu pro vpoet cest metodou Monte Carlo

global uk nasl hrany vzdal

vzdal_arch=vzdal;           % archivace grafu bez odebranch hran
Fk=zeros(R,length(skala));  % pprava matice pro zpis F_k
f=[];

prubeh=0;
for vypusteno=vyp         % cyklus pro zadan poty vypoutnch hran
    prubeh=prubeh+1;

    for j=1:R               % Monte Carlo
        vzdal=vzdal_arch;   % naten grafu bez odebranch hran
        
        % nsledujc funkce slou k vypoutn nhodnch hran a do poadovanho potu
        % vstupem je nov pole "vzdal" s odebranmi hranami - hodnotami Inf
        [vzdal]=vypousteni_hran(vypusteno);
        
        % Vypoteme dlky cest a dl vsledky metodou dle potu vrchol v grafu
        switch postup
            case 'primy vypocet'
                [Fks, fs]=cesty_prime_pocitani(skala);
            case 'MC'
                [Fks, fs]=cesty_MC(skala, opak, chyba);
                    % Fks - dl vsledky Fk
                    % fs  - vektor dlek nejkratch cest (na vykreslen histogramu)
        end;

       Fk(j,:)=Fks;      % dl vsledky Fk zapeme do matice
       f(length(f)+1:length(f)+length(fs))=fs;    % hodnoty pro histogram poskldme za sebe do vektoru
        
    end;
    
%     Tmto cyklem zjistme relativn etnosti dlek nejkratch cest z vektoru f
    delkaf=length(f);
    for p=0:(length(skala)/10)-2
        ff(p+1)=length(find(f>skala(10*p+1) & f<=skala(10*(p+1)+1) & f<Inf));
        osax(p+1)=skala(10*(p+1)+1);
    end;
  
    ff=ff/delkaf;       % relativn etnosti
         
    prumer_Fk(prubeh,:)=mean(Fk);   % v dcch jsou vsledn hodnoty pro zadan poty vyputnch hran
    fff(prubeh,:)=ff;               % v dcch jsou relativn etnosti pro zadan poty vyputnch hran
    
end;

