% Algoritmus pot S_k pro zadan poty vyputnch hran
    % postupn vypout hrany v potu dle nastaven na zatku cyklu. 
    % Hrany se vol nhodn, ale mus bt rzn
    % Vsledkem je vektor hodnot S_k pro zadan poty vyputnch hran
    
    
function [prumer_Sk]=robustness_Sk(vyp, R)
%         uk, nasl, hrany, vzdal - zadn grafu
%         vyp - vektor pot vypoutnch hran, vol uivatel
%         R - poet iterac metody Monte Carlo, vol uivatel

global uk nasl hrany vzdal        
vzdal_arch=vzdal;       % archivace grafu bez odebranch hran
Sk=zeros(1,R);          % pednastaven pole pro zpis S_k
prumer_Sk=zeros(1,length(vyp));  % pednastaven pole pro zpis konenho vektoru S_k, pro zadan poty vyputnch hran
prubeh=0;           % pot skoky ve vypoutn hran dle nastaven

for vypusteno = vyp         % cyklus pro zadan poty vypoutnch hran
     prubeh=prubeh+1;
    
    for s=1:R                   % Monte Carlo
        vzdal=vzdal_arch;       % naten grafu bez odebranch hran

        % nsledujc funkce slou k vypoutn nhodnch hran a do poadovanho potu
        % vstupem je nov pole "vzdal" s odebranmi hranami - hodnotami Inf
        [vzdal]=vypousteni_hran(vypusteno);

        [komp,pocet]=komponenty();     % funkce na zjitn komponent souvislosti
            % komp - pole s sly komponent, do kterch pat jednotliv vrcholy
            % pocet - nejvy slo komponenty = nejvt prvek v komp

        % Zjistme poet propojench vrchol v grafu. Je-li v dan
        % komponent 2 a vce uzl, spotme poet dvojic jako kombinaci a
        % zapeme do vektoru, jinak zstane pednastaven 0.
        dvojic=zeros(1, pocet);             % pednastaven vektoru
        for k=1:pocet
            N=length(find(komp==k));        % zjitn potu uzl v komponentch
            if N>=2
                dvojic(k)=nchoosek(N,2);    % kombinace dvojic z N uzl v dan komponent
            end;     
        end;
        pocet_dvojic=sum(dvojic);   % seteme dvojice v jednotlivch komponentch
        
        jmenovatel=(length(uk)-1)*(length(uk)-2)/2;     % jmenovatel dle definice S_k
        
        Sk(s)=pocet_dvojic/jmenovatel;      % Spotme S_k a zapeme do vektoru (opakovan)              
    end;
    
    % po danm potu opakovn pro dan poet hran spotme prmrn Sk
    % pro tento poet hran a zapeme do vslednho vektoru
    prumer_Sk(prubeh)=mean(Sk);   % vektor prmrnch Sk pro nastaven poty vyputnch hran   
  
end;

